﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Stimulsoft_Wpf
{
    public class Top
    {
        public string Name { get; set; }
        public int Number { get; set; }
        private List<Middle> ChildList { get; set; }
        public IEnumerable<Middle> Children {get { return ChildList; }}
        public Top ()
        {
            ChildList = new List<Middle>();
            Name = Misc.RandomString();
            Number = new Random().Next();
            for (int i = 0; i < new Random().Next(50, 100); i++)
                ChildList.Add(new Middle(this));
        }
    }

    public class Middle
    {
        public string Name { get; set; }
        public int Number { get; set; }
        public DateTime Date { get; set; }
        public Top Parent { get; set; }
        private IList<Bottom> ChildList { get; set; }
        public IEnumerable<Bottom> Children { get { return ChildList; } }

        public Middle (Top parent)
        {
            ChildList = new List<Bottom>();
            Parent = parent;
            Name = Misc.RandomString();
            Number = new Random().Next();
            Date = DateTime.Now;
            for (int i = 0; i < new Random().Next(10,100); i++)
                ChildList.Add(new Bottom(this));
        }
    }

    public class Bottom
    {
        public string Name { get; set; }
        public int Number { get; set; }
        public Middle Parent { get; set; }

        public Bottom (Middle parent)
        {
            Parent = parent;
            Name = Misc.RandomString();
            Number = new Random().Next();
        }

    }

    

    public class Misc
    {
        public static string RandomString()
        {
            return Path.GetRandomFileName().Replace(".", ""); // Remove period.
        }
    }
}
