﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Stimulsoft;
using Stimulsoft.Report;

namespace Stimulsoft_Wpf
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private IList<Top> Items;
        public MainWindow()
        {
            InitializeComponent();
            Items = new List<Top>();

            for (int i = 0; i < 100; i++)
                Items.Add(new Top());
        }

        private void btnDesign_Click(object sender, RoutedEventArgs e)
        {
            //GetReport().DesignWithWpf();

            StiReport mainReport = new StiReport();
            //mainReport.Load();    //Won't compile

                StiReport repDetailA = new StiReport();
                repDetailA.Load("TestReportA.mrt");
                mainReport.SubReports.Add(repDetailA);

                StiReport repDetailB = new StiReport();
                repDetailB.Load("TestReportB.mrt");
                mainReport.SubReports.Add(repDetailB);

                StiReport repDetailC = new StiReport();
                repDetailC.Load("TestReportC.mrt");
                mainReport.SubReports.Add(repDetailC);


            mainReport.RenderWithWpf();     //Generates error "Stimulsoft.Report.Win not found"
            mainReport.ShowWithWpf();


        }

        private StiReport GetReport()
        {
            var er = Assembly.GetExecutingAssembly().GetManifestResourceStream("Stimulsoft_Wpf.Report.mrt");
            
            //We've been using this option for about a year now, as we discovered it was required in normal useage
            // with our use of NHibernate and business objects, otherwise the report tends to traverse many
            // slow objects and use lots of RAM.
            //StiOptions.Dictionary.BusinessObjects.MaxLevel = 1;
            var r = new StiReport();
            r.Load(er);
            r.RegData("Items", Items.ToArray());
            //r.RegData("DoubleAnonymous", new {Level1s = "String1", Level1i = 1111, Level2 = new {Level2s = "String2", Level2i = 2222}});            
            return r;
        }
        
    }
}
